apiVersion: {{ sts_apivers }}
kind: StatefulSet
metadata:
  labels:
{% if do_backups and redis_persistent | default(False) %}
    backups.opsperator.io/driver: ssh
{% if (backups_interval | default('daily')) == 'hourly' %}
    backups.opsperator.io/interval: hourly
    backups.opsperator.io/preferredtime: "{{ backups_hourly_start_minute | default(15)}}"
{% elif (backups_interval | default('daily')) == 'weekly' %}
    backups.opsperator.io/interval: weekly
    backups.opsperator.io/preferredtime: "{{ backups_weekly_start_day | default(0) }}"
{% else %}
    backups.opsperator.io/interval: daily
    backups.opsperator.io/preferredtime: "{{ backups_daily_start_hour | default(2) }}"
{% endif %}
    backups.opsperator.io/secret: backups-{{ redis_name }}
    backups.opsperator.io/service: backups-{{ redis_name }}
{% endif %}
{% if pki_set | length > 0 %}
    pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    {{ network_policy_deployment_label }}: {{ redis_name }}
  name: {{ redis_name }}
  namespace: {{ namespace }}
spec:
  podManagementPolicy: Parallel
  replicas: {{ redis_replicas }}
  selector:
    matchLabels:
      name: {{ redis_name }}
  serviceName: {{ redis_name }}
  template:
    metadata:
      labels:
        name: {{ redis_name }}
{% if pki_set | length > 0 %}
        pki.opsperator.io/has-ca: {{ pki_set | join(',') }}
{% endif %}
    spec:
{% if do_affinities | default(True) %}
      affinity:
        podAntiAffinity:
{% if scheduling_affinity_required %}
          requiredDuringSchedulingIgnoredDuringExecution:
          - labelSelector:
              matchExpressions:
              - key: name
                operator: In
                values: [ {{ redis_name }} ]
            topologyKey: {{ k8s_affinity_zone_label }}
{% else %}
          preferredDuringSchedulingIgnoredDuringExecution:
          - podAffinityTerm:
              labelSelector:
                matchExpressions:
                - key: name
                  operator: In
                  values: [ {{ redis_name }} ]
              topologyKey: {{ k8s_affinity_zone_label }}
            weight: 42
{% endif %}
{% endif %}
      automountServiceAccountToken: false
      containers:
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: REDIS_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: REDIS_DOWN_TIMEOUT
          value: "3"
{% if redis_password | default(False) %}
        - name: REDIS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ redis_name }}
{% endif %}
        - name: REDIS_REPLICASET
          value: {{ redis_name }}
        - name: SENTINEL_SVC
          value: {{ redis_name }}-client
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='redis'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if (redis_replicas | int) > 1 %}
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 20
{% else %}
          failureThreshold: 5
          initialDelaySeconds: 15
{% endif %}
          periodSeconds: 10
          tcpSocket:
            port: 6379
          timeoutSeconds: 2
        name: redis
        ports:
        - containerPort: 6379
        readinessProbe:
          exec:
            command:
{% if (redis_replicas | int) > 1 %}
            - /bin/sh
            - "-i"
            - "-c"
            - /is-ready.sh
{% else %}
            - /usr/local/bin/redis-cli
            - "-h"
            - 127.0.0.1
{% if redis_password | default(False) %}
            - "-a"
            - "${REDIS_PASSWORD}"
{% endif %}
            - "-p"
            - "6379"
            - ping
{% endif %}
          initialDelaySeconds: 10
          periodSeconds: 5
        resources:
          limits:
            cpu: "{{ redis_cpu_limit }}"
            memory: "{{ redis_memory_limit }}"
          requests:
            cpu: "{{ redis_cpu_limit }}"
            memory: "{{ redis_memory_limit }}"
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 15
          tcpSocket:
            port: 6379
          timeoutSeconds: 2
{% endif %}
        volumeMounts:
        - mountPath: /var/lib/redis/data
          name: data
{% if (redis_replicas | int) > 1 %}
      - env:
        - name: DEBUG
          value: "{% if do_debugs %}yay{% endif %}"
        - name: IS_SENTINEL
          value: yep
        - name: REDIS_HOSTNAME
          valueFrom:
            fieldRef:
              fieldPath: metadata.name
        - name: REDIS_DOWN_TIMEOUT
          value: "3"
        - name: REDIS_QUORUM
{% if (redis_replicas | int) > 2 %}
          value: "{{ redis_quorum | default(2) }}"
{% else %}
          value: "1"
{% endif %}
{% if redis_password | default(False) %}
        - name: REDIS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ redis_name }}
{% endif %}
        - name: REDIS_REPLICASET
          value: {{ redis_name }}
        - name: SENTINEL_SVC
          value: {{ redis_name }}-client
        - name: TZ
          value: {{ timezone }}
        image: {{ (opsimages | json_query("[?name=='redis'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 20
          periodSeconds: 10
          tcpSocket:
            port: 26379
          timeoutSeconds: 2
        name: sentinel
        ports:
        - name: sentinel
          containerPort: 26379
        readinessProbe:
          exec:
            command:
            - /bin/sh
            - "-i"
            - "-c"
            - /is-ready.sh
          initialDelaySeconds: 10
          periodSeconds: 20
          timeoutSeconds: 2
        resources:
          limits:
            cpu: {{ sentinel_cpu_limit }}
            memory: {{ sentinel_memory_limit }}
          requests:
            cpu: {{ sentinel_cpu_limit }}
            memory: {{ sentinel_memory_limit }}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 15
          tcpSocket:
            port: 26379
          timeoutSeconds: 2
{% endif %}
{% endif %}
{% if do_exporters %}
      - args:
{% if do_debugs %}
        - --debug
{% endif %}
        - --redis.addr=redis://127.0.0.1:6379
        env:
{% if redis_password | default(False) %}
        - name: REDIS_PASSWORD
          valueFrom:
            secretKeyRef:
              key: password
              name: {{ redis_name }}
{% endif %}
        - name: REDIS_EXPORTER_INCL_SYSTEM_METRICS
          value: "true"
        image: {{ (opsimages | json_query("[?name=='redisexporter'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
        livenessProbe:
{% if k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ] %}
          failureThreshold: 20
{% else %}
          failureThreshold: 5
{% endif %}
          initialDelaySeconds: 30
          periodSeconds: 20
          tcpSocket:
            port: 9121
          timeoutSeconds: 3
        name: exporter
        ports:
        - containerPort: 9121
        resources:
          limits:
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
          requests:
{% if ensure_dbs_has_guaranteed_qosclass | default(True) %}
            cpu: "{{ exporter_cpu_limit }}"
            memory: "{{ exporter_memory_limit }}"
{% else %}
            cpu: "{{ exporter_cpu_request }}"
            memory: "{{ exporter_memory_request }}"
{% endif %}
{% if not (k8s_flavor == 'openshift' and ocp_major in [ 3, '3' ]) %}
        startupProbe:
          failureThreshold: 20
          initialDelaySeconds: 20
          periodSeconds: 20
          tcpSocket:
            port: 9121
          timeoutSeconds: 2
{% endif %}
{% endif %}
{% if do_backups and redis_persistent | default(False) %}
{% if do_triggers == False or sshd_short == False %}
      - image: {{ (opsimages | json_query("[?name=='sshd'].image"))[0] }}
        imagePullPolicy: {{ pull_policy }}
{% else %}
      - imagePullPolicy: {{ pull_policy }}
{% endif %}
        livenessProbe:
          initialDelaySeconds: 30
          tcpSocket:
            port: 2222
          timeoutSeconds: 3
        name: sshd
        ports:
        - containerPort: 2222
        resources:
          limits:
            cpu: {{ sshd_cpu_limit }}
            memory: {{ sshd_memory_limit }}
          requests:
            cpu: "{{ sshd_cpu_request }}"
            memory: "{{ sshd_memory_request }}"
        volumeMounts:
        - mountPath: /home/backup
          name: tmp
          subPath: bkphome
        - mountPath: /var/backup
          name: tmp
          subPath: bkpvar
        - mountPath: /.ssh/id_rsa.pub
          name: ssh
          subPath: id_rsa.pub
        - mountPath: /backups
          name: data
{% endif %}
{% if k8s_resource_nodes_selectors | length > 0 %}
      nodeSelector:
{% for sel in k8s_resource_nodes_selectors %}
        {{ sel.split('=')[0] }}: "{{ sel.split('=')[1] if (sel.split('=') | length > 1) else '' }}"
{% endfor %}
{% endif %}
{% if k8s_flavor == 'kubernetes' or (k8s_flavor == 'openshift' and ocp_major in [ 4, '4' ]) %}
      priorityClassName: opsperator-cache
{% endif %}
{% if (redis_persistent | default(False) and rwo_needs_fsgroup | default(False)) or ('net.core.somaxconn' in allowed_unsafe_sysctls) %}
      securityContext:
{% if redis_persistent | default(False) and rwo_needs_fsgroup | default(False) %}
        fsGroup: {{ rwo_needs_fsgroup }}
{% endif %}
{% if 'net.core.somaxconn' in allowed_unsafe_sysctls %}
        sysctls:
        - name: net.core.somaxconn
          value: "10000"
{% endif %}
{% endif %}
{% if 'net.core.somaxconn' in allowed_unsafe_sysctls and (k8s_flavor == 'kubernetes' and do_podsecuritypolicy) or k8s_flavor == 'openshift' %}
      serviceAccountName: {{ redis_name }}
{% else %}
      serviceAccountName: default
{% endif %}
      terminationGracePeriodSeconds: {{ redis_termination_timeout | default(600 if (redis_persistent | default(False)) else 10) }}
{% if do_topology_spread_constraints | default(False) %}
      topologySpreadConstraints:
      - labelSelector:
          matchLabels:
            name: {{ redis_name }}
        maxSkew: {{ topology_spread_max_skew | default(1) }}
        topologyKey: {{ k8s_affinity_zone_label }}
{% if scheduling_affinity_required %}
        whenUnsatisfiable: DoNotSchedule
{% else %}
        whenUnsatisfiable: ScheduleAnyway
{% endif %}
{% endif %}
{% if not (redis_persistent | default(False)) %}
      volumes:
      - emptyDir: {}
        name: data
{% elif do_backups and redis_persistent | default(False) %}
      volumes:
      - name: ssh
        secret:
          secretName: backups-{{ redis_name }}
      - emptyDir: {}
        name: tmp
{% endif %}
  updateStrategy:
    type: RollingUpdate
{% if redis_persistent | default(False) %}
  volumeClaimTemplates:
  - metadata:
      name: data
    spec:
      accessModes: [ ReadWriteOnce ]
      resources:
        requests:
          storage: "{{ redis_data_capacity }}"
{% if rwo_storage is defined %}
      storageClassName: {{ rwo_storage }}
{% endif %}
{% endif %}
